package uebung07;

import java.util.Collections;
import java.util.EnumSet;
import java.util.LinkedList;

/**
 * 
 * @author Lorenz Schauer
 * 
 * Übungsaufgabe vom Javakurs für Fortgeschrittene am 03.07.2019
 * Programm Black Jack zum Umgang mit weiteren Datenstrukturen
 * Hier: Beispiellösung mit LinkedList (Es gibt viele andere Wege).
 *
 */
public class Dealer {
	
	private LinkedList<Cards> karten;
	
	public Dealer(){	
		
		// Dealer erzeugt sich zu Beginn ein frisches Kartenset:
		
		// Kartenset aus je einem Kartentyp, die als Enums in Cards gespeichert sind => 13 Blatt 
		this.karten = new LinkedList<Cards>(EnumSet.allOf(Cards.class));
		
		//2 mal verdoppeln => 52 Blatt:
		karten.addAll(karten);
		karten.addAll(karten);
		
		// Kartenset mischen: 
		Collections.shuffle(karten);
	}
	
	// Dealer kann die oberste Karte vom Stapel abgeben:
	// D.h. 1. Karte zurückliefern und vom Stapel löschen:
	public Cards gibKarteAb(){
		Cards abgabe = this.karten.getFirst();
		this.karten.removeFirst();
		return abgabe;
	}
	
	
	public static void main(String[] args) {
		
		// Erzeuge 1 Dealer und 2 Spieler:
		Dealer d = new Dealer();
		Player spieler1 = new Player("Spieler 1");
		Player spieler2 = new Player("Spieler 2");


		//Solange beide Spieler Karten wollen läuft eine Spiel-Runde:
		while(spieler1.willZiehen()||spieler2.willZiehen()){
			
			// Falls Spieler den Wunsch hat zu ziehen:
			if(spieler1.willZiehen())
				// Spieler bekommt Karte vom Dealer
				spieler1.ziehenVomStapel(d.gibKarteAb());
			
			// Analog für Spieler 2:
			if(spieler2.willZiehen())
				spieler2.ziehenVomStapel(d.gibKarteAb());
		}// Spiel-Ende
	
		System.out.println("Spielende.\n");
		// Karten und Punktestände zeigen:
		System.out.println("Karten Spieler 1: ");
		spieler1.showCards();
		System.out.println("Punktestand Spieler 1 : "+spieler1.getPunkteStand());
		
		System.out.println("\nKarten Spieler 2: ");
		spieler2.showCards();
		System.out.println("Punktestand Spieler 2 : "+spieler2.getPunkteStand());
	}

}
