package uebung07;

import java.util.Collection;
import java.util.Iterator;
import java.util.LinkedList;


public class Player {
	
	private String name;
	private Collection<Cards> cardsOnHand;
	
	// Spieler besitzt Name und eine Datenstruktur für die Karten auf der Hand
	public Player(String name){
		this.name = name; 
		this.cardsOnHand = new LinkedList<Cards>();
	}
	
	
	// Spieler kann eine Karte vom Dealer bekommen:
	public void ziehenVomStapel(Cards karte){
		
		System.out.println(this.name+" zieht "+karte);
		cardsOnHand.add(karte);
	}
	
	// Spieler muss sein Punktestand errechnen können:
	public int getPunkteStand(){
		
		Iterator<Cards> myCardIterator = this.cardsOnHand.iterator();
		
		int summe=0;
		
		while(myCardIterator.hasNext()){
			
			Cards karte = myCardIterator.next();
			
			// Für das Mapping der Karte zu Punkte wird eine private Hilfsfunktion genutzt.
			summe +=mapCardToPoints(karte);
		}
		
		// Gibt Summe zurück
		return summe;
	}
	
	// Karten zeigen
	public void showCards(){
		Iterator<Cards> myCardIterator = this.cardsOnHand.iterator();
		
		while(myCardIterator.hasNext()){
			
			System.out.println(myCardIterator.next().name());
		}
	}
	
	// Spiel-Strategie: Solange mein Punktestand < 18 ist, will ich noch eine Karte ziehen
	public boolean willZiehen(){
		
		boolean ziehen = false;
		
		if (getPunkteStand()<=17)
			ziehen=true;
		
		return ziehen; 
	}
	
	// Hilfsfunktion zum mappen der Karten und der Punkte
	private int mapCardToPoints(Cards c){
		
		int value=-1;
		
		switch(c){
			
		case TWO: value=2;break;
		case THREE: value=3;break;
		case FOUR: value=4;break;
		case FIVE: value=5;break;
		case SIX: value=6;break;
		case SEVEN: value=7;break;
		case EIGHT: value=8;break;
		case NINE: value=9;break;
		case TEN: value=10;break;
		case JACK: value=10;break;
		case QUEEN: value=10;break;
		case KING: value=10;break;
		case AS: value=11;break;
		
		}
		
		return value; 
	}
}
